<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">

  <modelVersion>4.0.0</modelVersion>
  <groupId>de.grogra</groupId>
  <artifactId>GroIMP</artifactId>
  <version>2.1.6</version>
  <packaging>pom</packaging>
                      
  <name>GroIMP</name>

  <url>https://gitlab.com/grogra/groimp</url>

	<profiles>
		<!-- A profile that performe both app and doc compilation -->
		<profile>
		    <id>app-with-doc</id>
	    
		    <build>
		    <plugins>
			
		      <plugin>
		       <artifactId>maven-antrun-plugin</artifactId>
		       <version>3.1.0</version>
		        <executions>
					<!-- This execution copy some directories (namely plugins & textures) the final folder -->
		         <execution>
					 <id>copy-plugins</id>
			          <phase>package</phase>
			          <inherited>false</inherited>
			          <goals>
			             <goal>run</goal>
			          </goals>
			          <configuration>
			             <target>
		                     <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
							 <if>
		                        <available file="${basedir}/plugins" type="dir"/>
		                        <then>
		                            <echo>Copy the additional plugins to the package. </echo>
									<copy todir="${basedir}/app/plugins" includeEmptyDirs="true">
										<fileset dir="${basedir}/plugins" includes="**/**"/>
								  	</copy> 
								  	<copy todir="${basedir}/app/plugins/Textures" includeEmptyDirs="false">
										<fileset dir="${basedir}/Textures/src" includes="**/**"/>
								  	</copy> 
		                        </then>
		                    </if>
			             </target>
			          </configuration>
			       </execution>
			        <execution>
				        <id>compile-md</id>
				        <phase>${maven.assembly.generate.docbook}</phase>
				        <configuration>
				            <target>
								<taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
								<exec executable="pandoc">
									<arg value="-t"/>
									<arg value="docbook"/>
									<arg value="-i"/>
									<arg line="${MarkdownDocFile}"/>
									<arg value="--template"/>
									<arg value="src/main/resources/doc/template.docbook"/>
									<arg value="-V"/>
									<arg value="title=${Name}"/>
									<arg value="--lua-filter"/>
									<arg value="src/main/resources/doc/copyfilter.lua"/>
									<arg value="-o"/>
									<arg value="src/main/resources/doc/manual.xml"/>
									<arg value="--top-level-division=chapter"/>
				                </exec>
				            </target>
				        </configuration>
				        <goals>
				            <goal>run</goal>
				        </goals>
				    </execution>


			       <execution>
				        <id>compile-doc</id>
				        <phase>compile</phase>
				        <configuration>
				            <target>
						          <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
												 <if>
		                 				 <available file="${basedir}/src/main/resources/doc/manual.xml" />
		                  <then>
				          		  <mkdir dir="target/classes/doc"/>
				                <exec executable="xsltproc">
				                    <arg value="--catalogs"/>
														<arg value="--xinclude"/>
														<arg value="--output"/>
														<arg file="target/classes/doc/index.html"/>
														<arg value="--stringparam"/>
														<arg value="section.autolabel"/>
														<arg value="1"/>
														<arg value="--stringparam"/>
														<arg value="section.label.includes.component.label"/>
														<arg value="1"/>
														<arg value="--stringparam"/>
														<arg value="suppress.navigation"/>
														<arg value="0"/>
														<arg file="/usr/share/xml/docbook/stylesheet/docbook-xsl/htmlhelp/htmlhelp.xsl"/>
														<arg file="src/main/resources/doc/manual.xml"/>
				                </exec>
				                <copy todir="target/classes/doc/res" failonerror="false">
														<fileset dir="src/main/resources/doc/res"/>
												</copy>
											 </then>
                			</if>
				            </target>
				        </configuration>
				        <goals>
				            <goal>run</goal>
				        </goals>
				    </execution>
				    
			       
		        </executions>
		        <dependencies>
		        <dependency>
		            <groupId>ant-contrib</groupId>
		            <artifactId>ant-contrib</artifactId>
		            <version>1.0b3</version>
		            <exclusions>
		                <exclusion>
		                    <groupId>ant</groupId>
		                    <artifactId>ant</artifactId>
		                </exclusion>
		            </exclusions>
		        </dependency>
		        <dependency>
		            <groupId>org.apache.ant</groupId>
		            <artifactId>ant-nodeps</artifactId>
		            <version>1.8.1</version>
		        </dependency>
		    </dependencies>
		      </plugin>
		      

			      <plugin>
			        <groupId>de.grogra</groupId>
			        <artifactId>build</artifactId>
			        <version>1.1</version>
			        <!-- To uncomment if run enhance-src with ALL compilation - can still be called with mvn de.grogra:build:enhance-src -->
			        <executions>
			            <execution>
			            		<phase>generate-sources</phase>
			                <goals>
			                    <goal>enhance-src</goal>
			                </goals>
			            </execution>
			        </executions>
			    </plugin>
			  </plugins>
			  
    <pluginManagement>
      <plugins>  
      
      <plugin>
	          <artifactId>maven-clean-plugin</artifactId>
	          <version>3.3.1</version>
	          <inherited>false</inherited>
	          <configuration>
			      <filesets>
			        <fileset>
			          <directory>app</directory>
			          <followSymlinks>false</followSymlinks>
			        </fileset>
			      </filesets>
			    </configuration>
	        </plugin>
	                                                                
	        <plugin>
	          <artifactId>maven-resources-plugin</artifactId>
	          <version>3.3.1</version>
	        </plugin>
	        
	        <plugin>
	          <artifactId>maven-compiler-plugin</artifactId>
	          <version>3.11.0</version>
	          <configuration>
	            <source>${maven.compiler.source}</source>
	            <target>${maven.compiler.target}</target>
	          </configuration>
	        </plugin>
	        
	
	        <plugin>
	          <artifactId>maven-surefire-plugin</artifactId>
	          <version>3.1.2</version>
	        </plugin>
	
	        <plugin>
	          <artifactId>maven-jar-plugin</artifactId>
	          <version>3.3.0</version>
	        </plugin>
	
	        <plugin>
	          <artifactId>maven-install-plugin</artifactId>
	          <version>3.1.1</version>
	        </plugin>
	
	        <plugin>
	          <artifactId>maven-deploy-plugin</artifactId>
	          <version>3.1.1</version>
	        </plugin>
	                                                                                        
	        <plugin>
	          <artifactId>maven-project-info-reports-plugin</artifactId>
	          <version>3.4.5</version>
	        </plugin>
	
	        <plugin>
      <groupId>org.apache.maven.plugins</groupId>
      <artifactId>maven-shade-plugin</artifactId>
      <version>3.5.0</version>
    </plugin>
          
		  <plugin>
              <groupId>org.apache.maven.plugins</groupId>
              <artifactId>maven-assembly-plugin</artifactId>
              <version>${maven.assembly.plugin.version}</version>
              <executions>
                  <execution>
                      <id>make-assembly</id>
                      <phase>package</phase>
                      <goals>
                          <goal>single</goal>
                      </goals>
                      <configuration>
						<appendAssemblyId>false</appendAssemblyId>
						<descriptors>
				            <descriptor>src/assembly/assembly.xml</descriptor>
	          			</descriptors>
	          			<outputDirectory>${plugins.directory}</outputDirectory>
	                </configuration>
                  </execution>
                  <execution>
                      <id>move-lib</id>
                      <phase>${maven.assembly.plugin.move-lib}</phase>
                      <goals>
                          <goal>single</goal>
                      </goals>
                      <configuration>
						<finalName>lib</finalName>
						<appendAssemblyId>false</appendAssemblyId>
						<descriptors>
				            <descriptor>src/assembly/lib.xml</descriptor>
	          			</descriptors>
	          			<outputDirectory>${project.build.directory}</outputDirectory>
	                </configuration>
                  </execution>
              </executions>
          </plugin>
          <!-- to add in child project to get the source enhanced -->
            
		<plugin>
      <groupId>org.apache.maven.plugins</groupId>
      <artifactId>maven-javadoc-plugin</artifactId>
      <version>3.8.0</version>
			<configuration>
		    <noqualifier>all</noqualifier>
				<doclint>none</doclint>
				<destDir>javadoc</destDir>
				<overview>Build/src/main/resources/overview.html</overview>
				<doctitle>GroIMP ${groimp.core.version} API</doctitle> 
				<excludePackageNames>*jedit*</excludePackageNames>
			</configuration>
      <executions>
        <execution>
          <id>attach-javadocs</id>
          <phase>javadoc</phase>
          <goals>
            <goal>aggregate</goal>
          </goals>
        </execution>

      </executions>
    </plugin>
          
      </plugins>                                               
    </pluginManagement>

	  </build>
	</profile>
	
	<!-- The default profile package as the app folder at the root. It require no additional parameters -->
		<profile>
		    <id>app</id>
		    <activation>
		        <activeByDefault>true</activeByDefault>
		    </activation>
		    
		    <build>
		    <plugins>
			
		      <plugin>
		       <artifactId>maven-antrun-plugin</artifactId>
		       <version>3.1.0</version>
		        <executions>
					<!-- This execution copy some directories (namely plugins & textures) the final folder -->
		         <execution>
					 <id>copy-plugins</id>
			          <phase>package</phase>
			          <inherited>false</inherited>
			          <goals>
			             <goal>run</goal>
			          </goals>
			          <configuration>
			             <target>
		                     <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
							 <if>
		                        <available file="${basedir}/plugins" type="dir"/>
		                        <then>
		                            <echo>Copy the additional plugins to the package. </echo>
									<copy todir="${basedir}/app/plugins" includeEmptyDirs="true">
										<fileset dir="${basedir}/plugins" includes="**/**"/>
								  	</copy> 
								  	<copy todir="${basedir}/app/plugins/Textures" includeEmptyDirs="false">
										<fileset dir="${basedir}/Textures/src" includes="**/**"/>
								  	</copy> 
		                        </then>
		                    </if>
			             </target>
			          </configuration>
			       </execution>
			       
		        </executions>
		        <dependencies>
		        <dependency>
		            <groupId>ant-contrib</groupId>
		            <artifactId>ant-contrib</artifactId>
		            <version>1.0b3</version>
		            <exclusions>
		                <exclusion>
		                    <groupId>ant</groupId>
		                    <artifactId>ant</artifactId>
		                </exclusion>
		            </exclusions>
		        </dependency>
		        <dependency>
		            <groupId>org.apache.ant</groupId>
		            <artifactId>ant-nodeps</artifactId>
		            <version>1.8.1</version>
		        </dependency>
		    </dependencies>
		      </plugin>
		      
			      <plugin>
			        <groupId>de.grogra</groupId>
			        <artifactId>build</artifactId>
			        <version>1.1</version>
			        <!-- To uncomment if run enhance-src with ALL compilation - can still be called with mvn de.grogra:build:enhance-src -->
			        <executions>
			            <execution>
			            		<phase>generate-sources</phase>
			                <goals>
			                    <goal>enhance-src</goal>
			                </goals>
			            </execution>
			        </executions>
			    </plugin>
			  </plugins>
			  
    <pluginManagement>
      <plugins>  
      
      <plugin>
	          <artifactId>maven-clean-plugin</artifactId>
	          <version>3.3.1</version>
	          <inherited>false</inherited>
	          <configuration>
			      <filesets>
			        <fileset>
			          <directory>app</directory>
			          <followSymlinks>false</followSymlinks>
			        </fileset>
			      </filesets>
			    </configuration>
	        </plugin>
	                                                                
	        <plugin>
	          <artifactId>maven-resources-plugin</artifactId>
	          <version>3.3.1</version>
	        </plugin>
	        
	        <plugin>
	          <artifactId>maven-compiler-plugin</artifactId>
	          <version>3.11.0</version>
	          <configuration>
	            <source>${maven.compiler.source}</source>
	            <target>${maven.compiler.target}</target>
	          </configuration>
	        </plugin>
	        
	
	        <plugin>
	          <artifactId>maven-surefire-plugin</artifactId>
	          <version>3.1.2</version>
	        </plugin>
	
	        <plugin>
	          <artifactId>maven-jar-plugin</artifactId>
	          <version>3.3.0</version>
	        </plugin>
	
	        <plugin>
	          <artifactId>maven-install-plugin</artifactId>
	          <version>3.1.1</version>
	        </plugin>
	
	        <plugin>
	          <artifactId>maven-deploy-plugin</artifactId>
	          <version>3.1.1</version>
	        </plugin>
	                                                                                        
	        <plugin>
	          <artifactId>maven-project-info-reports-plugin</artifactId>
	          <version>3.4.5</version>
	        </plugin>
	
	        <plugin>
      <groupId>org.apache.maven.plugins</groupId>
      <artifactId>maven-shade-plugin</artifactId>
      <version>3.5.0</version>
    </plugin>
          
		  <plugin>
              <groupId>org.apache.maven.plugins</groupId>
              <artifactId>maven-assembly-plugin</artifactId>
              <version>${maven.assembly.plugin.version}</version>
              <executions>
                  <execution>
                      <id>make-assembly</id>
                      <phase>package</phase>
                      <goals>
                          <goal>single</goal>
                      </goals>
                      <configuration>
						<appendAssemblyId>false</appendAssemblyId>
						<descriptors>
				            <descriptor>src/assembly/assembly.xml</descriptor>
	          			</descriptors>
	          			<outputDirectory>${plugins.directory}</outputDirectory>
	                </configuration>
                  </execution>
                  <execution>
                      <id>move-lib</id>
                      <phase>${maven.assembly.plugin.move-lib}</phase>
                      <goals>
                          <goal>single</goal>
                      </goals>
                      <configuration>
						<finalName>lib</finalName>
						<appendAssemblyId>false</appendAssemblyId>
						<descriptors>
				            <descriptor>src/assembly/lib.xml</descriptor>
	          			</descriptors>
	          			<outputDirectory>${project.build.directory}</outputDirectory>
	                </configuration>
                  </execution>
              </executions>
          </plugin>
          <!-- to add in child project to get the source enhanced -->
           
      </plugins>                                               
    </pluginManagement>

  </build>
	    
	</profile>
			
		<!-- The release profile run additionally to the app, a packaging of the 3 os supported (win, deb, and osx). It 
		requires the Build/ module to be working. -->
		<profile>
		    <id>release</id>
			<build>

			  <plugins>
			
		      <plugin>
		       <artifactId>maven-antrun-plugin</artifactId>
		       <version>3.1.0</version>
		       <inherited>false</inherited>
		       <executions>
			       <!-- Create the release files - only done if Build plugin is threre -->
			       <execution>
							 <id>create-release</id>
			          <phase>validate</phase>
			          <inherited>false</inherited>
			          <goals>
			             <goal>run</goal>
			          </goals>
			          <configuration>
			             <target>
							 <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
							 <if>
                    <available file="${basedir}/Build/build.xml"/>
                    <then>
                        <echo>Make releases. </echo>
									<ant antfile="${basedir}/Build/build.xml">
						                <target name="Frelease"/>
						            </ant>
		                        </then>
		                        <else>
									<echo>The Build plugin isn't accessible under /Build/build.xml. </echo>
								</else>
		                    </if>
			             </target>
			          </configuration>
			       </execution>		
			       
		        </executions>
		        <dependencies>
		        <dependency>
		            <groupId>ant-contrib</groupId>
		            <artifactId>ant-contrib</artifactId>
		            <version>1.0b3</version>
		            <exclusions>
		                <exclusion>
		                    <groupId>ant</groupId>
		                    <artifactId>ant</artifactId>
		                </exclusion>
		            </exclusions>
		        </dependency>
		        <dependency>
	            <groupId>org.apache.ant</groupId>
	            <artifactId>ant-nodeps</artifactId>
	            <version>1.8.1</version>
	        </dependency>
	    </dependencies>
	      </plugin>
	      
		  </plugins>

  </build>
      
		</profile>
		<!-- The release-win profile is a sub execution of the release. It only produce the windows release. -->
		<profile>
		    <id>release-win</id>
			<build>
			   <plugins>
			
		      <plugin>
		       <artifactId>maven-antrun-plugin</artifactId>
		       <version>3.1.0</version>
		       <inherited>false</inherited>
		       <executions>
			       <!-- Create the release files - only done if Build plugin is threre -->
			       <execution>
							 <id>create-release</id>
			          <phase>validate</phase>
			          <inherited>false</inherited>
			          <goals>
			             <goal>run</goal>
			          </goals>
			          <configuration>
			             <target>
							 <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
							 <if>
                    <available file="${basedir}/Build/build.xml"/>
                    <then>
                        <echo>Make releases. </echo>
									<ant antfile="${basedir}/Build/build.xml">
						                <target name="winexe"/>
						            </ant>
		                        </then>
		                        <else>
									<echo>The project doesn't seems to be packaged. </echo>
								</else>
		                    </if>
			             </target>
			          </configuration>
			       </execution>		
			       
		        </executions>
		        <dependencies>
		        <dependency>
		            <groupId>ant-contrib</groupId>
		            <artifactId>ant-contrib</artifactId>
		            <version>1.0b3</version>
		            <exclusions>
		                <exclusion>
		                    <groupId>ant</groupId>
		                    <artifactId>ant</artifactId>
		                </exclusion>
		            </exclusions>
		        </dependency>
		        <dependency>
	            <groupId>org.apache.ant</groupId>
	            <artifactId>ant-nodeps</artifactId>
	            <version>1.8.1</version>
	        </dependency>
	    </dependencies>
	      </plugin>
	      
		  </plugins>

  </build>
  
		</profile>
		<!-- The release-deb profile is a sub execution of the release. It only produce the debian release. -->
		<profile>
		    <id>release-deb</id>
			<build>
			  <plugins>
			
		      <plugin>
		       <artifactId>maven-antrun-plugin</artifactId>
		       <inherited>false</inherited>
		       <executions>
			       <!-- Create the release files - only done if Build plugin is threre -->
			       <execution>
							 <id>create-release</id>
			          <phase>package</phase>
			          <inherited>false</inherited>
			          <goals>
			             <goal>run</goal>
			          </goals>
			          <configuration>
			             <target>
							 <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
							 <if>
                    <available file="${basedir}/Build/build.xml"/>
                    <then>
                        <echo>Make Debian release. </echo>
									<ant antfile="${basedir}/Build/build.xml">
						                <target name="deb"/>
						            </ant>
		                        </then>
		                        <else>
									<echo>The project doesn't seems to be packaged. </echo>
								</else>
		                    </if>
			             </target>
			          </configuration>
			       </execution>		
			       
		        </executions>
		        <dependencies>
		        <dependency>
		            <groupId>ant-contrib</groupId>
		            <artifactId>ant-contrib</artifactId>
		            <version>1.0b3</version>
		            <exclusions>
		                <exclusion>
		                    <groupId>ant</groupId>
		                    <artifactId>ant</artifactId>
		                </exclusion>
		            </exclusions>
		        </dependency>
		        <dependency>
	            <groupId>org.apache.ant</groupId>
	            <artifactId>ant-nodeps</artifactId>
	            <version>1.8.1</version>
	        </dependency>
	    </dependencies>
	      </plugin>
	      
		  </plugins>

  </build>
		</profile>
		<!-- The release-osx profile is a sub execution of the release. It only produce the osx release. -->
		<profile>
		    <id>release-osx</id>
			<build>
			  <plugins>
			
		      <plugin>
		       <artifactId>maven-antrun-plugin</artifactId>
		       <inherited>false</inherited>
		       <executions>
			       <!-- Create the release files - only done if Build plugin is threre -->
			       <execution>
							 <id>create-release</id>
			          <phase>package</phase>
			          <inherited>false</inherited>
			          <goals>
			             <goal>run</goal>
			          </goals>
			          <configuration>
			             <target>
							 <taskdef resource="net/sf/antcontrib/antlib.xml" classpathref="maven.dependency.classpath" />
							 <if>
                    <available file="${basedir}/Build/build.xml"/>
                    <then>
                        <echo>Make Debian release. </echo>
									<ant antfile="${basedir}/Build/build.xml">
						                <target name="maczip"/>
						            </ant>
		                        </then>
		                        <else>
									<echo>The project doesn't seems to be packaged. </echo>
								</else>
		                    </if>
			             </target>
			          </configuration>
			       </execution>		
			       
		        </executions>
		        <dependencies>
		        <dependency>
		            <groupId>ant-contrib</groupId>
		            <artifactId>ant-contrib</artifactId>
		            <version>1.0b3</version>
		            <exclusions>
		                <exclusion>
		                    <groupId>ant</groupId>
		                    <artifactId>ant</artifactId>
		                </exclusion>
		            </exclusions>
		        </dependency>
		        <dependency>
	            <groupId>org.apache.ant</groupId>
	            <artifactId>ant-nodeps</artifactId>
	            <version>1.8.1</version>
	        </dependency>
	    </dependencies>
	      </plugin>
	      
		  </plugins>

  </build>
		    
		</profile>
	</profiles>
	
  <properties>
    <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    <maven.compiler.source>17</maven.compiler.source>
    <maven.compiler.target>17</maven.compiler.target>
   
    <app.directory>../app</app.directory>
    <plugins.directory>${app.directory}/plugins</plugins.directory>
    <maven.assembly.plugin.version>3.5.0</maven.assembly.plugin.version>
    <maven.assembly.plugin.move-lib>None</maven.assembly.plugin.move-lib>
	<maven.assembly.generate.docbook>None</maven.assembly.generate.docbook>
	<MarkdownDocFile>README.md</MarkdownDocFile>

    
    <groimp.core.version>[2.1.6,)</groimp.core.version>
  </properties>
  
  
  <distributionManagement>
    <snapshotRepository>
      <id>gitlab-com</id>
      <url>https://gitlab.com/api/v4/projects/${env.CI_PROJECT_ID}/packages/maven</url>
    </snapshotRepository>
    <repository>
      <id>gitlab-com</id>
      <url>https://gitlab.com/api/v4/projects/${env.CI_PROJECT_ID}/packages/maven</url>
    </repository>
  </distributionManagement>

  <scm>
    <connection>scm:git:${env.CI_REPOSITORY_URL}</connection>
    <url>${env.CI_PROJECT_URL}</url>
    <developerConnection>scm:git:${env.CI_REPOSITORY_URL}</developerConnection>
    <tag>HEAD</tag>
  </scm>
 <!-- -->
<repositories>
  <repository>
    <id>gitlab-maven</id>
    <url>https://gitlab.com/api/v4/groups/55048746/-/packages/maven</url>
  </repository>
  <repository>
    <id>saxonica</id>
    <url>https://dev.saxonica.com/maven</url>
  </repository>
</repositories>
<pluginRepositories>
	<pluginRepository>
	  <id>gitlab-maven</id>
	  <url>https://gitlab.com/api/v4/groups/55048746/-/packages/maven</url>
	</pluginRepository>
</pluginRepositories>

  <dependencies>
    <dependency>     
      <groupId>junit</groupId>
      <artifactId>junit</artifactId>
      <version>4.11</version>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>de.grogra</groupId>
      <artifactId>build</artifactId>
      <version>1.1</version>
    </dependency>
	<dependency>
			<groupId>com.saxonica</groupId>
			<artifactId>xmldoclet</artifactId>
			<version>0.4.0</version>
			<scope>test</scope>
			<exclusions>
			    <exclusion>
			      <groupId>net.sf.saxon</groupId>
			      <artifactId>Saxon-HE</artifactId>
			    </exclusion>
	 		 </exclusions>
	</dependency>
  </dependencies>


  <modules>

<!-- CORE -->

	<module>Grammar</module>
	<module>Graph</module>
  <module>Math</module>
  <module>Numeric</module>
	<module>IMP</module>
  <module>IMP-2D</module>
  <module>IMP-3D</module>
	<module>Utilities</module>
  <module>Vecmath</module>
	<module>XL-Core</module>
  <module>XL-VMX</module>
  <module>XL-Impl</module>
  <module>XL-Compiler</module>
  <module>XL</module>
  <module>Platform</module>
  <module>Platform-Core</module>
  <module>ProjectManager</module>
	<module>Plugin-Manager</module>

	<module>Platform-Swing</module>
	<module>Raytracer</module>

  </modules>
</project>
